// main
IR.AddListener(IR.EVENT_START, 0, function()
{ 
   //SaveStorage(['pbx.peoplefone.ch', 5060, 'PrZK34eJ.3', '90723505368'], 'servers');
   //SaveStorage(['192.168.0.41', 5060, 'pwd101', '101'], 'servers');
   //SaveStorage(['192.168.0.43', 5060, 'pwd101', '101'], 'servers');
   //SaveStorage(['pbx.peoplefone.ch', 5060, '9Xh8J3.LnD', '90793256181'], 'servers');
   
   IR.SetVariable("Global.head_trigger", 3);
   //IR.GetPopup("Camera").GetItem("Item 1").GetState(0).Image = "sip_image://";
   IR.GetPopup("Camera").GetItem("Item 2").GetState(0).Image = "ir_camera://";
   
   IR.Camera(IR.CAMERA_RECORD, IR.CAMERA_FRONT, IR.CAMERA_RESOLUTION_MEDIUM);
      
   calls = [];       // calls book   
   canceled = null;  // canceled variable
      
   // elements
   page = IR.GetPage("main");
   popup = IR.GetPopup("Incoming");
   
   add_new_popup = IR.GetPopup("add_in_phonebook");
   sure_popup = IR.GetPopup("sure");
   panel = IR.GetPopup("Panel");
            
   servers = IR.GetPopup("Servers");
   if(servers) {
      servers_list = servers.GetItem("List");
   }
   
   if(page)   
      ebx = page.GetItem("Item 2");
   if(panel) {   
      list = panel.GetItem("List");
      send_notty = panel.GetItem("send_notty");
      phone_book = panel.GetItem("phone_book");
   }  
   
   if(add_new_popup) {
      new_number = add_new_popup.GetItem("number_ebx");
      new_name = add_new_popup.GetItem("name_ebx");
      add = add_new_popup.GetItem("add");
   }
   
   // change server
   change_popup = IR.GetPopup("dyn_change");
   if(change_popup) {  
      change_server = {
         host : change_popup.GetItem("host_ebx"),
         port : change_popup.GetItem("port_ebx"),
         cid : change_popup.GetItem("cid_ebx"),
         id : change_popup.GetItem("id_ebx"),
         pwd : change_popup.GetItem("pwd_ebx"),
         change : change_popup.GetItem("change"),
      };
   }
      
   // add server
   add_server = IR.GetPopup("add_server");
   if(change_popup) {  
      add_server_items = {
         host : add_server.GetItem("host_ebx"),
         port : add_server.GetItem("port_ebx"),
         cid : add_server.GetItem("cid_ebx"),
         id : add_server.GetItem("id_ebx"),
         pwd : add_server.GetItem("pwd_ebx"),
         add : add_server.GetItem("add"),
      };
   }
   
   if(sure_popup) {
      yes = sure_popup.GetItem("Yes");
      no = sure_popup.GetItem("No");
   }
   // abonent who will be deleted after aplly
   abonent_to_delete = null;
   
   aa = IR.GetPopup("Properties").GetItem("auto_answer").Value;   // auto answer
      
   // adds abonent in book list
   function AddAbonent(param)
   {
      count = phone_book.ItemsCount;
      phone_book.CreateItem(count, 1, { Text : param[0] });
      phone_book.CreateItem(count, 3, { Text : param[1] });
   }
   
   function FillServersList(params)
   {
      count = servers_list.ItemsCount;
      servers_list.CreateItem(count, 1, { Text : params[0] });
      servers_list.CreateItem(count, 2, { Text : params[1] });
      //servers_list.CreateItem(count, 3, { Text : params[2] });
      servers_list.CreateItem(count, 5, { Text : params[3] });
   }
   
   FillListFromStorage('phone_book', AddAbonent);
   FillListFromStorage('servers', FillServersList);
      
   // функция звонка. будет вызвана с интервалом
   function Call(isVideo)
   {
      // получение устройства с именем SIP и вызов его канала с идентификатором 2 (CALL Channel).
      IR.GetDevice("SIP").Set("CALL", isVideo ? 1 : 0);
   }
   
   function Answer(isVideo)
   {
      if(isVideo == 1)
         IR.GetPopup("Camera").GetItem("Item 1").GetState(0).Image = "sip_image://";
      
      number = IR.GetVariable("Drivers.SIP.INCOMING CALL NUMBER");      
      AddCallToList(number, 'Answered', 0x0000FFFF);
      canceled = null;
   }
      
   // SIP events handling 
   IR.AddListener(IR.EVENT_TAG_CHANGE, IR.GetDevice("SIP"), function(name, value) 
   {  
      //IR.Log('tag change ' + name + ' ' + value);     
      if(name == 'INCOMING CALL')
      {
         // Alerting.wav is looping. can call yourself?
         if(value == 1)
         {
            if(aa == 1)
            {
               var isVideo = 1;
               Answer(isVideo);
               IR.GetDevice("SIP").Set("ANSWER", isVideo);   
            }
            else
            {
               IR.ShowPopup('Incoming');
               IR.PlaySound("Ringing.wav", 0, 50, true);
            }
            
            canceled = IR.GetVariable("Drivers.SIP.INCOMING CALL NUMBER");
         }
         else
         {
            IR.HidePopup('Incoming');
            IR.StopSound("Ringing.wav");
            //IR.Log('>> Missed Call!:' + canceled);
                        
            AddCallToList(canceled, 'Missed', 0xFF0000FF);
            canceled = null;
         }
      }
      if(name == 'STATUS')
      {
         if(value != 'Ringing...' || value != 'Trying...')
         {
            IR.StopSound("Alerting.wav");
         }
         
         /*if(value == 'Talking...')
         {
            IR.StopSound("Alerting.wav");
         } else*/
         if(value == 'On Hook...')
         {
            //IR.StopSound("Alerting.wav");
            IR.GetPopup("Camera").GetItem("Item 1").GetState(0).Image = "Xzibit.png";
         }
      }
   });
   
   // Store Call
   function AddCallToList(text, type, color)
   {
      if(list && text && text != '')
      {
         count = list.ItemsCount;
         list.CreateItem(count, 5, { Text : text });
         list.CreateItem(count, 1, { Text : type });
         list.CreateItem(count, 1, { FillColor : color });
         // save number
         calls.push(text);
      }
   }
   
   // On Call press
   IR.AddListener(IR.EVENT_ITEM_PRESS, page.GetItem("Item 3"), function() 
   {
      // fill list
      AddCallToList(ebx.Text, 'Outgoing', 0x0FF00FF);  
   });
   // On Video Call press
   IR.AddListener(IR.EVENT_ITEM_PRESS, page.GetItem("Item 17"), function() 
   {
      IR.GetPopup("Camera").GetItem("Item 1").GetState(0).Image = "sip_image://";
      AddCallToList(ebx.Text, 'Outgoing', 0x0FF00FF);
   });
   
   // On Answer press
   IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("Item 4"), function() 
   {
      Answer(0);
   });
   // On Video Answer press
   IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("Item 17"), function() 
   {
      Answer(1);
   });
   
   // On Cancel press
   IR.AddListener(IR.EVENT_ITEM_PRESS, page.GetItem("Item 4"), function() {
      // nothing
      IR.StopSound("Ringing.wav");
      ebx.Text = "";
      IR.GetPopup("Camera").GetItem("Item 1").GetState(0).Image = "Xzibit.png";
   });
   
   // ====== All this Listeners Can be Deleted if not used ======
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('r0'), function() { IR.Camera(IR.CAMERA_ROTATE, 0); });
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('r90'), function() { IR.Camera(IR.CAMERA_ROTATE, 90); });
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('r180'), function() { IR.Camera(IR.CAMERA_ROTATE, 180); });
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('r270'), function() { IR.Camera(IR.CAMERA_ROTATE, 270); });
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('flipv'), function() 
   { 
      var val = IR.GetPopup('Camera').GetItem('flipv').Value;
      IR.Camera(IR.CAMERA_FLIP_VERTICAL, val); 
   });
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Camera').GetItem('fliph'), function() 
   {
      var val = IR.GetPopup('Camera').GetItem('fliph').Value;
      IR.Camera(IR.CAMERA_FLIP_HORIZONTAL, val); 
   });
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup("Camera").GetItem("stop_cam"), function()
   {
      IR.Camera(IR.CAMERA_STOP);
   });
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup("Camera").GetItem("start_cam"), function()
   {
      IR.Camera(IR.CAMERA_RECORD, IR.CAMERA_FRONT, IR.CAMERA_RESOLUTION_MEDIUM);   
   });
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup("Properties").GetItem("auto_answer"), function()
   {
      aa = IR.GetPopup("Properties").GetItem("auto_answer").Value;   
   });
   
   function Connect()
   {
      IR.GetDevice("SIP").Connect();
   }
   
   function Disconnect()
   {
      IR.GetDevice("SIP").Disconnect();
   }
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPage('main').GetItem('Connect'), Connect);
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPage('main').GetItem('Disconnect'), Disconnect);
   
   function ClearCallList()
   {
      var list = IR.GetPopup('Panel').GetItem('List');
      if(list)
         list.Clear();
   }
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetPopup('Panel').GetItem('ClearList'), function(item, subitem) {
      ClearCallList()
   });
   
   // On List press 
   IR.AddListener(IR.EVENT_ITEM_SELECT, list, function(item, subitem) 
   {
      IR.Log(subitem);
      if(subitem == 2) 
      {
         // add number in phonebook
         IR.ShowPopup("add_in_phonebook");
         num = calls[item];
         new_number.Text = num;
      }
      else if(subitem == 3)
      {
         num = calls[item];
         ebx.Text = num;
         
         IR.SetTimeout(40, function() { IR.GetDevice("SIP").Set("CALL", 0);});
      }
      else if(subitem == 4)
      {
         num = calls[item];
         ebx.Text = num;
         
         IR.SetTimeout(40, function() { IR.GetDevice("SIP").Set("CALL", 1);});
      }
      // redial 
      else
      { 
         num = calls[item];
         ebx.Text = num;
         
         IR.SetTimeout(40, Call);
         //IR.GetDevice("SIP").Set(2, '0');
      }             
   });
      
   // On Servers List press 
   IR.AddListener(IR.EVENT_ITEM_SELECT, servers_list, function(item, subitem) {
      IR.Log(subitem);
      if(subitem == '3') { // delete
         DeleteFromStorage(item, 'servers', servers_list);
      } else if(subitem == '4') { // make current         
         param = GetFromStorage(item, 'servers');
         if(param) {
            new_params = { 
               Host : param[0],
               Port : parseInt(param[1], 10),
               CallerID : param[3],
               ID : param[3],
               Password : param[2],
               FirstRTPPort : 7082,
               LastRTPPort : 8000,
               ToneDTMF : true,
               ToneSIP : false,
               BackGroundMode : false,
            };
      
            IR.GetDevice("SIP").SetParameters(new_params);
         }
      }
   });
   
   // On Add new abonent in phonebook press
   /*IR.AddListener(IR.EVENT_ITEM_PRESS, add, function() {
      if(new_name.Text && new_number.Text) 
      { 
         //SetAbonent(new_name.Text, new_number.Text);
         SaveStorage([new_name.Text, new_number.Text], 'phone_book');
         AddAbonent([new_name.Text, new_number.Text]);
         IR.HidePopup("add_in_phonebook");
      } else
      {
         IR.Log('Some fields is empty');
      }
   });*/
   
   // On Phone Book List press 
   IR.AddListener(IR.EVENT_ITEM_SELECT, phone_book, function(item, subitem) {
      // delete pressed
      if(subitem == 2)
      {
         IR.ShowPopup("sure");
         abonent_to_delete = item;
         //DeleteAbonent(item); 
      } else
      {
         ebx.Text = GetFromStorage(item, 'phone_book')[1];//GetAbonent(item);
         // to fast for first time. click twice
         Call();
         //IR.GetDevice("SIP").Set("CALL", '0');       
      }
   });
   
   // On change server's parameters
   IR.AddListener(IR.EVENT_ITEM_PRESS, change_server.change, function() {
      new_params = { 
         Host : change_server.host.Text,
         Port : parseInt(change_server.port.Text, 10),
         CallerID : change_server.cid.Text,
         ID : change_server.id.Text,
         Password : change_server.pwd.Text,
         FirstRTPPort : 40000,
         LastRTPPort : 40100,
         ToneDTMF : true,
         ToneSIP : false,
      };
      
      IR.GetDevice("SIP").SetParameters(new_params);
   });
      
   // On add server
   IR.AddListener(IR.EVENT_ITEM_PRESS, add_server_items.add, function() {
      server_params = { 
         Host : add_server_items.host.Text,
         Port : add_server_items.port.Text, //parseInt(add_server_items.port.Text, 10),
         CallerID : add_server_items.id.Text, // cid == id !!!
         ID : add_server_items.id.Text,
         Password : add_server_items.pwd.Text,
         FirstRTPPort : 40000,
         LastRTPPort : 40100,
         ToneDTMF : true,
         ToneSIP : false,
      };
      
      FillServersList([server_params.Host, server_params.Port, server_params.Password, server_params.ID]);
      
      SaveStorage([server_params.Host, server_params.Port, server_params.Password, server_params.ID], 'servers'); 
   });
   
   // On Yes, I'm want delete abonent from adress book 
   IR.AddListener(IR.EVENT_ITEM_PRESS, yes, function() {
      
      //DeleteAbonent(abonent_to_delete);
      DeleteFromStorage(abonent_to_delete, 'phone_book', phone_book);
      IR.HidePopup("sure");
      abonent_to_delete = null;
   });
   
   // On No, I'm not want delete abonent from adress book 
   IR.AddListener(IR.EVENT_ITEM_PRESS, no, function() {
      IR.HidePopup("sure");
      abonent_to_delete = null;
   });
});